PRO gosaveitall,yy,xx,lon,lat,fname
l=n_elements(yy)
get_lun,wqu
openw,wqu,strcompress(fname,/remove_all)
for i=0,l-1,1 do begin
printf,wqu,format='(2(1x,f7.1),4(1x,f15.7))',lon(i),lat(i),yy(i),xx(*,i)
print,format='(2(1x,f7.1),4(1x,f15.7))',lon(i),lat(i),yy(i),xx(*,i)
endfor
close,wqu
free_lun,wqu
return
end

 PRO make_zonal_mean_residual,residuals_gridded_stack,longrid,latgrid,yyyymm_arr
mosequence=fix(strmid(yyyymm_arr,4,2))
print,'Mo seq.',mosequence
l=size(residuals_gridded_stack,/dimensions)
nlon=l(0)
nlat=l(1)
ntime=l(2)
zonal=fltarr(12,nlat)
for ilat=0,nlat-1,1 do begin
for it=1,12,1 do begin
idx=where(mosequence eq it)
zonal(it-1,ilat)=mean(residuals_gridded_stack(*,ilat,idx),/NaN)
endfor
endfor
;
device,/close
set_plot,'ps'
device,filename='Zonal_avg_residuals.ps',/color
!P.MULTI=[0,2,2]
contour,zonal,indgen(12)+1,latgrid(0,*),/cell_fill,nlevels=101,xstyle=1,ystyle=1,title='Zonal mean error'
contour,zonal,indgen(12)+1,latgrid(0,*),levels=[-0.3,-0.2,-0.15,-0.125,-0.1,-0.05,-0.025,0,0.025,0.05,.1,.125,.15,.2,.3],xstyle=1,ystyle=1,c_thick=[1,1,1,1,1,1,1,3,1,1,1,1,1,1,1],/OVERPLOT,c_labels=indgen(15)*0+1
print,min(zonal,/NAN),max(zonal,/NAN)
device,/close
return
end

PRO make_stack_residuals,residuals_gridded,longrid,latgrid,icount
common keeper,residuals_gridded_stack
if (icount eq 0) then residuals_gridded_stack=residuals_gridded
if (icount gt 0) then residuals_gridded_stack=[[[residuals_gridded_stack]],[[residuals_gridded]]]
return
end

 PRO go_save_stack,exp_str,namelabel,stack,longrid,latgrid,yyyymm_arr
 three_d_write_netcdf,longrid,latgrid,yyyymm_arr,stack,strcompress(exp_str+namelabel+'_stack.nc',/remove_all),namelabel
return
end


PRO  get_CERES_albedo_nc,cereslon,cereslat,ceresalbedo,file
 ncdf_cat,file
 id = NCDF_OPEN(file)
 NCDF_VARGET, id, 'lon',    cereslon
 NCDF_VARGET, id, 'lat',    cereslat
 NCDF_VARGET, id, 'CERES_albedo',    ceresalbedo
 NCDF_CLOSE,  id
 return
 end
 
 PRO get_CERES_albedo,file,ceresalbedo,cereslon,cereslat
 ; returns three 2D arrays - albedo and lon and lat
 ; Sample usage:
 ;file='CERES_SurfaceAlbedo.nc'
 ;ncdf_cat,file
 ;get_CERES_albedo,file,ceresalbedo,cereslon,cereslat
 ;ncdf_cat,file
 id = NCDF_OPEN(file)
 NCDF_VARGET, id, 'lon',    cereslon
 NCDF_VARGET, id, 'lat',    cereslat
 NCDF_VARGET, id, 'albedo',    ceresalbedo
 NCDF_CLOSE,  id
 ; since lon and lat are 1D we need to create the 2D equivalents
 newlon=ceresalbedo*0.0
 newlat=ceresalbedo*0.0
 for i=0,2159,1 do begin
     for j=0,1079,1 do begin
         newlon(i,j)=cereslon(i)
         newlat(i,j)=cereslat(j)
         endfor
     endfor
 cereslon=newlon
 cereslat=newlat
 return
 end
 
 
 
 
 PRO get_one_NETCDF_file,file,gridded,longrid,latgrid,existflag
 common wantedgrid,dlon1,dlat1,nlon1,nlat1
 ;============================================
 print,'Infile : ',file
 existflag=314
 if (file_test(file)) then begin
     print,'File exists'
     ;ncdf_cat,file
     id = NCDF_OPEN(file)
     NCDF_VARGET, id, 'lon',    longrid
     NCDF_VARGET, id, 'lat',    latgrid
     NCDF_VARGET, id, 'Data1',    gridded
     NCDF_CLOSE,  id
     help,gridded,latgrid,longrid
     stop
     existflag=1
     endif
 return
 end
 
 PRO get_d_factor,IGBPgrid,longrid,latgrid,mugrid,d_grid,factorgrid
 ; will return, in 'factorgrid' the 'd' factor needed in (1+d)/(1+2*d*mugrid)
 ;============================================
 ; translate the surface type index in IGBPgrid to a 'd' number
 ; excerpt from Fortran code that uses these factors 
 ; - see Trentmann Jörg <joerg.trentmann@dwd.de> CMSAF about this
 ;   REAL, PARAMETER :: d ( nigbp) = &
 ;      (/ 0.40,  & ! ( 1) EVERGREEN NEEDLE FOR
 ;      0.44,  & ! ( 2) EVERGREEN BROAD FOR
 ;      0.32,  & ! ( 3) DECIDUOUS NEEDLE FOR
 ;      0.39,  & ! ( 4) DECIDUOUS BROAD FOR
 ;      0.22,  & ! ( 5) MIXED FOREST
 ;      0.28,  & ! ( 6) CLOSED SHRUBS
 ;      0.40,  & ! ( 7) OPEN/SHRUBS
 ;      0.15,  & ! ( 8) WOODY SAVANNA
 ;      0.27,  & ! ( 9) SAVANNA
 ;      0.22,  & ! (10) GRASSLAND
 ;      0.35,  & ! (11) WETLAND
 ;      0.24,  & ! (12) CROPLAND (CAGEX-APR)
 ;      0.10,  & ! (13) URBAN
 ;      0.12,  & ! (14) CROP MOSAIC
 ;      0.10,  & ! (15) ANTARCTIC SNOW
 ;      0.40,  & ! (16) BARREN/DESERT
 ;      0.41,  & ! (17) OCEAN WATER
 ;      0.58,  & ! (18) TUNDRA
 ;      0.10,  & ! (19) FRESH SNOW
 ;      0.10 /)  ! (20) SEA ICE
 dvals=[911,0.4,0.44,0.32,0.39,0.22,0.28,0.4,0.15,0.27,0.22,0.35,0.24,0.1,0.12,0.1,0.4,0.41,0.58,0.1,0.1,911]
 d_grid=IGBPgrid*0.0+911
 for i=1,20,1 do begin
     idx=where(IGBPgrid eq i)
     if (idx(0) ne -1) then d_grid(idx)=dvals(i)
     endfor
 ; check that no pixels have not been assigned
 if (where(abs(d_grid) eq 911) ne -1) then stop
 ; Formula is from eq (7) of Briegleb et al 1986 in J Clim App Met vol 25, pp 214-226. Note the typo there!
 factorgrid=(1.0+d_grid)/(1.0+2.0*d_grid*mugrid)
 return
 end
 
 PRO get_landsurface_type,IGBP,lon,lat
 common paths,path
 common landsurftype,IGBPdummy,lonIGBP,latIGBP
 ;============================================
 f=path+'/cmsaf/cmsaf-cld3/pthejll/CMSAFDATA/AUXILLIARY/CERES_IGBP_LandCover_1x1.nc'
 f=path+'/cmsaf/cmsaf-cld3/pthejll/CMSAFDATA/AUXILLIARY/CERES_IGBP_LandCover_60s60w60e60n_remaplnn.nc'
 f=path+'/cmsaf/cmsaf-cld3/pthejll/CMSAFDATA/AUXILLIARY/CERES_IGBP_LandCover_60s60w60e60n_remaplaf.nc'
 id = NCDF_OPEN(f)
 NCDF_VARGET, id, 'lon',    lon
 NCDF_VARGET, id, 'lat',    lat
 NCDF_VARGET, id, 'IGBP',   IGBP 
 NCDF_CLOSE,  id
 ; fix the row of -1000s
 idx=where(IGBP lt 0)
 if (idx(0) ne -1) then IGBP(idx)=17
 ; fill up the common block
 lonIGBP=lon
 latIGBP=lat
 IGBPdummy=IGBP
 return
 end
 
 PRO get_cossza_file,mm,lon,lat,yyyymm_str
 common paths,path
 ;============================================
 if_type=1	; read the binary meanCOSsza files 
 if_type=2 	; read the netcdf meanCOSsza files
 if (if_type eq 1) then begin
     ; These binary files were generated with the code "calculate_mean_cossza.pro"
     f=strcompress(path+'/cmsaf/cmsaf-cld3/pthejll/meancosSZA_'+yyyymm_str+'overland.bin')
     if (file_test(f) ne 1) then stop
     mm=dblarr(120,121)
     lon=fltarr(120,121)
     lat=fltarr(120,121)
     get_lun,ww
     openu,ww,f
     readu,ww,mm
     readu,ww,lon
     readu,ww,lat
     close,ww
     free_lun,ww
     endif
 if (if_type eq 2) then begin
     mm_str=strmid(yyyymm_str,4,2)
     fname=strcompress(path+'/cmsaf/cmsaf-cld3/pthejll/'+mm_str+'_meanCOSsza.nc',/remove_all)
     id = NCDF_OPEN(fname)
     NCDF_VARGET, id, 'lon',    lon
     NCDF_VARGET, id, 'lat',    lat
     NCDF_VARGET, id, 'mean_cos_SZA',   mm 
     NCDF_CLOSE,  id
     endif
 return
 end
 
 PRO get_one_file,file,gridded,longrid,latgrid,existflag
 common wantedgrid,dlon1,dlat1,nlon1,nlat1
 common strings,yyyymm_str
 ;============================================
 print,'Infile : ',file
 existflag=314
 if (file_test(file)) then begin
     ;     print,'File exists'
     data=CM_SAF_read_data(file)
     full_res= *data.data.(0).data
     regrid=lonlat2reg(full_res, (*data.geolocation.lon), (*data.geolocation.lat),$
     lat0=-60.0,lon0=-60.0,dlon=dlon1,dlat=dlat1,nlat=nlat1,nlon=nlon1, $
     nodata_value=data.data.(0).nodata_value)
     gridded=regrid.avg
     latgrid=regrid.lat
     longrid=regrid.lon
     print,'Min, Max of gridded values :',min(gridded),max(gridded)
     print,'Smallest not-zero value : ',min(gridded(where(gridded ne 0)))
     existflag=1
     endif
 ; for UNKNOWN reasons need to flip the TRS files always at least once
 print,'Testing file for TRSness:',(strpos(file,'TRS') ne -1)
 if (strpos(file,'TRS') ne -1) then begin
     gridded=reverse(gridded,1)
     print,'FLIPPING THE GRID'
     print,file
     endif
 ; test for the special problem of the flipped longitudes in TRS files
 bad_months=['200902','200906','200907','200908','200909','200910','200911','200912']
 answer=intarr(8)*0
 for k=0,7,1 do answer(k)=strpos(file,bad_months(k))
 ipointer=where(answer ne -1)
 print,answer
 if (ipointer(0) ne -1 and strpos(file,'TRS') ne -1) then begin
     gridded=reverse(gridded,1)
     print,'FLIPPING THE GRID in a special month'
     print,file
     endif
 return
 end
 
 PRO get_lsmask_gridded,file,lsmask,lon,lat
 ;============================================
 print,'In get_lsmask_gridded, file = ',file
 if (file_test(file) ne 1) then stop
 if (file_test(file)) then begin
     print,'Land-Sea mask exists:',file
     ;ncdf_cat,file
     id = NCDF_OPEN(file)
     NCDF_VARGET, id, 'lon',    lon
     NCDF_VARGET, id, 'lat',    lat
     NCDF_VARGET, id, 'Landmask',    lsmask
     NCDF_CLOSE,  id
     existflag=1
     endif
 return
 end
 
 PRO go_interpolate,array_in,lon_in,lat_in,array_gridded,longrid,latgrid
 ; will interpolate the data given as array_in,lon_in,lat_in onto the
 ; grid given by longrid,latgrid. The output data will be array_gridded
 ;============================================
 l1=size(array_in,/dimensions) & l2=size(lon_in,/dimensions) & l3=size(lat_in,/dimensions)
 if (total(l1) ne total(l2)) then begin
     print,'In go_interpolate: I think the arrays are supposed to bethe same size!'
     stop
     endif
 datvector=array_in
 lonvector=lon_in
 latvector=lat_in
 l=size(array_in,/dimension)
 if (n_elements(l) ne 1) then begin
     datvector=reform(array_in,float(l(0)*l(1)))
     if (n_elements(lon_in) eq l(0)*l(1)) then begin
         lonvector=reform(lon_in,float(l(0)*l(1)))
         latvector=reform(lat_in,float(l(0)*l(1)))
         endif
     if (n_elements(lon_in) eq l(0)) then begin
         lonvector=lon_in
         latvector=lat_in
         for k=1,l(1)-1,1 do lonvector=[lonvector,lon_in]
         for k=1,l(0)-1,1 do latvector=[latvector,lat_in]
         endif
     endif
 l2=size(longrid,/dimension)
 xoutvector=reform(longrid,float(l2(0)*l2(1)))
 youtvector=reform(latgrid,float(l2(0)*l2(1)))
 Result = GRIDDATA(lonvector, latvector, datvector, /SPHERE, /DEGREES, xout=xoutvector, yout=youtvector) 
 array_gridded=reform(Result,l2(0),l2(1))
 return
 end
 
 PRO get_JUST_d_factor,IGBPgrid,d_grid,longrid,latgrid
 ; will return, in the 'd' factor needed in (1+d)/(1+2*d*meanCosSZAgrid)
 ;
 ;============================================
 ; translate the surface type index in IGBPgrid to a 'd' number
 ;   REAL, PARAMETER :: d ( nigbp) = &
 ;      (/ 0.40,  & ! ( 1) EVERGREEN NEEDLE FOR
 ;      0.44,  & ! ( 2) EVERGREEN BROAD FOR
 ;      0.32,  & ! ( 3) DECIDUOUS NEEDLE FOR
 ;      0.39,  & ! ( 4) DECIDUOUS BROAD FOR
 ;      0.22,  & ! ( 5) MIXED FOREST
 ;      0.28,  & ! ( 6) CLOSED SHRUBS
 ;      0.40,  & ! ( 7) OPEN/SHRUBS
 ;      0.15,  & ! ( 8) WOODY SAVANNA
 ;      0.27,  & ! ( 9) SAVANNA
 ;      0.22,  & ! (10) GRASSLAND
 ;      0.35,  & ! (11) WETLAND
 ;      0.24,  & ! (12) CROPLAND (CAGEX-APR)
 ;      0.10,  & ! (13) URBAN
 ;      0.12,  & ! (14) CROP MOSAIC
 ;      0.10,  & ! (15) ANTARCTIC SNOW
 ;      0.40,  & ! (16) BARREN/DESERT
 ;      0.41,  & ! (17) OCEAN WATER
 ;      0.58,  & ! (18) TUNDRA
 ;      0.10,  & ! (19) FRESH SNOW
 ;      0.10 /)  ! (20) SEA ICE
 dvals=[911,0.4,0.44,0.32,0.39,0.22,0.28,0.4,0.15,0.27,0.22,0.35,0.24,0.1,0.12,0.1,0.4,0.41,0.58,0.1,0.1,-911]
 d_grid=IGBPgrid*0.0+911
 for i=1,20,1 do begin
     idx=where(IGBPgrid eq i)
     if (idx(0) ne -1) then d_grid(idx)=dvals(i)
     endfor
 if (where(abs(d_grid) eq 911) ne -1) then stop
 return
 end
 
 PRO get_factorgrid,factorgrid,iyear,im
 common paths,path
 common IGBP,IGBPgrid,dgrid,longrid,latgrid
 ;============================================
 ; get the IGBP land_surface type array
 get_landsurface_type,IGBPgrid,dummylon,dummylat
 ;    get the 'd' parameter for each pixel
 get_JUST_d_factor,IGBPgrid,dgrid,longrid,latgrid
 ;============================================
 ; now perform the mean over time for one month of (1+d)/(1+2*d*mu) ...
 if_calculate=1	; DONT DO THIS! It takes forever - calculate the grid 
 ; off-line using "calculate_mean_dfunction.pro"
 if_calculate=2
 
 if(if_calculate eq 1) then begin
     nlonorlat=120
     factorgrid=fltarr(nlonorlat,nlonorlat)+!VALUES.F_NAN
     ; Here is another hard-wire to the grid -60-60 (well, 59.5 ... but)
     longitude=findgen(nlonorlat)-59.5
     latitude=findgen(nlonorlat)-59.5
     for ilon=0,nlonorlat-1,1 do begin
         for ilat=0,nlonorlat-1,1 do begin
             icount=0L
             sum=0.0
             for id=1,30,1 do begin
                 for ih=0,23,1 do begin
                     imin=randomu(seed)*60.
                     JD=double(julday(im,id,iyear,ih,imin,0))
                     SUNPOS, jd, alpha0, delta0
                     eq2hor, alpha0, delta0, jd, alt_sun, az, ha,  lon=0.0, lat=latitude(ilat)
                     if (alt_sun ge 0.0) then begin
                         mu=cos(abs(90-alt_sun)*!dtor)
                         val=(1.+dgrid(ilon,ilat))/(1.+2.*dgrid(ilon,ilat)*mu)
                         sum=sum+val
                         print,format=fmt3,alt_sun,abs(90-alt_sun),mu,sum,val,latitude(ilat),imin,ih,id,icount
                         fmt3='(6(1x,f9.4),4(1x,i5))'
                         icount=icount+1
                         endif
                     endfor	; end of ih loop
                 endfor	; end of id loop
             factorgrid(ilon,ilat)=sum/float(icount)	; storing the mean of (1+d)/(1+2*d*mu)
             endfor	; end of ilat loop
         endfor	; end of ilon loop
     endif
 
 if (if_calculate eq 2) then begin
     file=strcompress(path+'/cmsaf/cmsaf-cld3/pthejll/CMSAFDATA/AUXILLIARY/'+im+'_meandfucntion.nc',/remove_all)
     file=file(0)
     id = NCDF_OPEN(file)
     NCDF_VARGET, id, 'lon',    lon
     NCDF_VARGET, id, 'lat',    lat
     NCDF_VARGET, id, 'mean_cos_SZA',    factorgrid
     NCDF_CLOSE,  id
     endif
 return
 end

 PRO pt_ncdf_put_3d,id,x,x_str,identity
 l=size(x)
 dim1=l(1)
 dim2=l(2)
 dim3=l(3)
 londim=ncdf_dimdef(id,'londim',dim1)
 latdim=ncdf_dimdef(id,'latdim',dim2)
 timedim=ncdf_dimdef(id,'timedim',dim3)
 identity=ncdf_vardef(id,x_str,[londim,latdim,timedim])
 ncdf_attput,id,identity,'long_name',x_str
 return
 end
 
 PRO pt_ncdf_put_2d,id,x,x_str,identity
 l=size(x)
 dim1=l(1)
 dim2=l(2)
 londim=ncdf_dimdef(id,'londim',dim1)
 latdim=ncdf_dimdef(id,'latdim',dim2)
 identity=ncdf_vardef(id,x_str,[londim,latdim])
 ncdf_attput,id,identity,'long_name',x_str
 return
 end
 
 PRO pt_ncdf_put_1d,id,x,x_str,identity
 londim=ncdf_dimdef(id,x_str,n_elements(x))
 identity=ncdf_vardef(id,x_str,[londim])
 ncdf_attput,id,identity,'long_name',x_str
 return
 end
 
 PRO three_d_write_netcdf,lon_in,lat_in,tstr,array3d,filename,variable_string
 ; will write a 3D array into a NETCDF file, storing only info on
 ; lon and lat and the actuall array
 l=size(array3d)
 if (l(0) ne 3) then stop
 lon=lon_in
 lat=lat_in
 id=ncdf_create(filename,/CLOBBER)
 ncdf_control,id,/FILL
 print,'lon dimensions : ',n_elements(size(lon,/dimensions))
 print,'lat dimensions : ',n_elements(size(lat,/dimensions))
 if (n_elements(size(lon,/dimensions)) eq 1) then pt_ncdf_put_1d,id,lon,'lon',lonid
 if (n_elements(size(lat,/dimensions)) eq 1) then pt_ncdf_put_1d,id,lat,'lat',latid
                                                  pt_ncdf_put_1d,id,tstr,'timestr',timeid
 if (n_elements(size(lon,/dimensions)) eq 2) then begin
     lon=reform(lon(*,0))
     pt_ncdf_put_1d,id,lon,'lon',lonid
     endif
 if (n_elements(size(lat,/dimensions)) eq 2) then begin
     lat=reform(lat(0,*))
     pt_ncdf_put_1d,id,lat,'lat',latid
     endif
 pt_ncdf_put_3d,id,array3d,variable_string,arrayid
 
 ncdf_control,id,/ENDEF
 NCDF_VARPUT,id,lonid,lon
 NCDF_VARPUT,id,latid,lat
 NCDF_VARPUT,id,timeid,tstr
 NCDF_VARPUT,id,arrayid,array3d
 
 NCDF_CLOSE,id
 return
 end
 PRO write_netcdf,lon_in,lat_in,array2d,filename,variable_string
 lon=lon_in
 lat=lat_in
 id=ncdf_create(filename,/CLOBBER)
 ncdf_control,id,/FILL
 print,'lon dimensions : ',n_elements(size(lon,/dimensions))
 print,'lat dimensions : ',n_elements(size(lat,/dimensions))
 if (n_elements(size(lon,/dimensions)) eq 1) then pt_ncdf_put_1d,id,lon,'lon',lonid
 if (n_elements(size(lat,/dimensions)) eq 1) then pt_ncdf_put_1d,id,lat,'lat',latid
 if (n_elements(size(lon,/dimensions)) eq 2) then begin
     lon=reform(lon(*,0))
     pt_ncdf_put_1d,id,lon,'lon',lonid
     endif
 if (n_elements(size(lat,/dimensions)) eq 2) then begin
     lat=reform(lat(0,*))
     pt_ncdf_put_1d,id,lat,'lat',latid
     endif
 pt_ncdf_put_2d,id,array2d,variable_string,arrayid
 
 ncdf_control,id,/ENDEF
 NCDF_VARPUT,id,lonid,lon
 NCDF_VARPUT,id,latid,lat
 NCDF_VARPUT,id,arrayid,array2d
 
 NCDF_CLOSE,id
 return
 end
 
 PRO get_map_of_annual_cycle,stack,longrid,latgrid,map
 l=size(stack,/dimensions)
 imo=indgen(l(2))+5
 map=fltarr(l(0),l(1))
 summer=where(imo ge 4 and imo le 8)
 winter=where(imo le 3 or imo ge 9)
 get_lun,iug
 openw,iug,'map_of_annaul_cycle_SAL.dat'
 printf,iug,l
 for ilon=0,l(0)-1,1 do begin
     for ilat=0,l(1)-1,1 do begin
         series=reform(stack(ilon,ilat,*))
         map(ilon,ilat)=(mean(series(winter))-mean(series(summer)))/mean(series)
         printf,iug,format='(2(f7.1,1x),'+string(l(2))+'(f9.4,1x))',longrid(ilon),latgrid(ilat),stack(ilon,ilat,*)
         endfor
     endfor
 close,iug
 free_lun,iug
 print,'Saved time series for all SAL in the file "map_of_annual_cycle_SAL.dat".'
 return
 end
 
 ;====================================================================================================
 ; Code to read hdf files of SAL, TIS, TRS, COT and CFC
 ; Builds a regression model of various factors - such as SAL and CFC against TRS/TIS
 ;====================================================================================================
 ; Version 18b 
 ; like version 17 but has a fourth model type
 ; New in 18b vs. '18': writes the monthly SAL and monthly CFC as two NETCDF files
 ;====================================================================================================
 ; NOTE At present setup flags etc are scattered through the code ... please review all of the code 
 ; before running; and read section x.xx in the report "xxxxxxx".
 ;====================================================================================================
 common wantedgrid,dlon,dlat,nlon,nlat
 common paths,path
 common strings,yyyymm_str
 common landsurftype,IGBP,lonIGBP,latIGBP
 common keeper,residuals_gridded_stack
 ;.................<<<<<<<<<<<<<<<<
 ; Find which machine this is
 res=get_login_info() 
 machine=res.machine_name
 ; set path to the CMSAF data files - i.e. to where /cmsaf/cmsaf-cld3 starts ...
 if (machine eq 'daddy-o') then path='/home/daddy-o/Desktop/ASTRO/FROMDWD'	; at home
 if (machine eq 'egregious') then path='/data/pth/CMSAF'	; at work
 ;.................<<<<<<<<<<<<<<<<
 ; set the Model type
 modeltype=1	; User can set 1-4 here - model is shown further down
 openw,88,'modeltype.str' & printf,88,modeltype & close,88
 ; set the type of CMSAF data file
 filetype=2	; netcdf	USE WITH CAUTION. CHECK CODE FIRST!
 filetype=1	; hdf
 !P.CHARSIZE=1.2
 ; go and get the Land-Sea mask
 file=path+'/cmsaf/cmsaf-cld3/pthejll/CMSAFDATA/AUXILLIARY/lsmask.nc'
 get_lsmask_gridded,file,lsmask,lsmasklon_DONOTUSE,lsmasklat_DONOTUSE
 ;.........................................................................
 ; Define the the lon/lat grid we wish to work on
 ; Note that the Full Disk area is well covered by a regular grid 60S-60W to 60N-60E
 dlon=1.0
 dlat=1.0
 nlon=120
 nlat=120
 ;.........................................................................
 ; also set up the area where the pixels will be used for regression
 ; and set up the experiment name to be used in file naming
 ; read in from the file set up in the calling 'go_exXX.pro' routine
 openr,9,'string.str'
 exp_str=''
 readf,9,exp_str
 lonmin=0 & lonmax=0 & latmin=0 & latmax=0
 readf,9,lonmin,lonmax,latmin,latmax
 close,9
 ;.........................................................................
 ; set up the name of the files we will read the CMSAF filenames from
 if (filetype eq 1) then bit=''
 if (filetype eq 2) then bit='_nc'
 ; then open the files with the lists of file names
 openr,1,strcompress('CFCliste'+bit+'.txt',/remove_all)
 openr,2,strcompress('TISliste'+bit+'.txt',/remove_all)
 openr,3,strcompress('TRSliste'+bit+'.txt',/remove_all)
 openr,4,strcompress('SALliste'+bit+'.txt',/remove_all)
 openr,5,strcompress('COTliste'+bit+'.txt',/remove_all)
 ; open file to hold output of regression coefficients and their uncertainties
 ; use "plot_regression_result.pro" to plot these values
 get_lun,w
 openw,w,strcompress(exp_str+'regression_results_Model'+string(modeltype)+'.dat',/remove_all)
 nvars=3
 if (modeltype eq 3) then nvars=2
 printf,w,nvars	; this is the number of regressors in the model
 nmonths=31
 nmonths=43
 nmonths=35
 sum_residuals=0.0 & sum_rel_residuals=0.0 & sum_COTgridded=0.0 & sum_SALgridded=0.0 & sum_CFCgridded=0.0 &sum_TRSgridded=0.0 &sum_TISgridded=0.0 
 get_lun,uw
 openw,uw,strcompress(exp_string+'Rsquared.dat',/remove_all)
 ; loop over the names given in each of the 4 lists
 icount=0
 openw,67,'all_regress_data.dat'
 for ifile=1,nmonths,1 do begin

     print,'----------------------------------------------------------------------'
     print,'file #: ',ifile
     CFCfile='' & TISfile='' & TRSfile='' & SALfile='' & COTfile=''
     readf,1,CFCfile
     readf,2,TISfile
     readf,3,TRSfile
     readf,4,SALfile
     readf,5,COTfile
     yyyymm_str=strmid(CFCfile,45,6)
     if (ifile eq 1) then yyyymm_arr=yyyymm_str
     if (ifile gt 1) then yyyymm_arr=[yyyymm_arr,yyyymm_str]
     ; get and regrid all data for this year and month, scale SAL and CFC to interval 0->1
     print,'filetype=',filetype
     if (filetype eq 1) then get_one_file,path+SALfile,SALgridded,longrid,latgrid,SALexist 
     if (filetype eq 2) then get_one_NETCDF_file,path+SALfile,SALgridded,longrid,latgrid,SALexist 
     SALgridded=SALgridded/100.0
     ; build a stack of the SALgridded
     if (icount eq 0) then SALstack=SALgridded
     if (icount gt 0) then SALstack=[[[SALstack]],[[SALgridded]]]
     ; build a sum for an average
     sum_SALgridded=SALgridded+sum_SALgridded
     print,'lon lat from SAL:'
     print,longrid(0:7)
     print,latgrid(0:7)
     if (filetype eq 1) then get_one_file,path+TRSfile,TRSgridded,longrid,latgrid,TRSexist
     if (filetype eq 2) then get_one_NETCDF_file,path+TRSfile,TRSgridded,longrid,latgrid,TRSexist
     ; build a sum for an average
     sum_TRSgridded=TRSgridded+sum_TRSgridded
     print,'lon lat from TRS:'
     print,longrid(0:7)
     print,latgrid(0:7)
     if (filetype eq 1) then get_one_file,path+COTfile,COTgridded,longrid,latgrid,COTexist
     if (filetype eq 2) then get_one_NETCDF_file,path+COTfile,COTgridded,longrid,latgrid,COTexist
     ; build a sum for an average
     sum_COTgridded=COTgridded+sum_COTgridded
     print,'lon lat from COT:'
     print,longrid(0:7)
     print,latgrid(0:7)
     if (filetype eq 1) then get_one_file,path+TISfile,TISgridded,longrid,latgrid,TISexist
     if (filetype eq 2) then get_one_NETCDF_file,path+TISfile,TISgridded,longrid,latgrid,TISexist
     ; build a sum for an average
     sum_TISgridded=TISgridded+sum_TISgridded
     print,'lon lat from TIS:'
     print,longrid(0:7)
     print,latgrid(0:7)
     if (filetype eq 1) then get_one_file,path+CFCfile,CFCgridded,longrid,latgrid,CFCexist 
     if (filetype eq 2) then get_one_NETCDF_file,path+CFCfile,CFCgridded,longrid,latgrid,CFCexist 
     CFCgridded=CFCgridded/100.0
     ; build a stack of the CFCgridded
     if (icount eq 0) then CFCstack=CFCgridded
     if (icount gt 0) then CFCstack=[[[CFCstack]],[[CFCgridded]]]
     ; build a sum for an average
     sum_CFCgridded=CFCgridded+sum_CFCgridded
     print,'lon lat from CFC:'
     print,longrid(0:7)
     print,latgrid(0:7)
     ; calculate the albedo
     albedo=(TRSgridded/TISgridded)
     ; make some labels from the file names : WARNING - HARDWIRED TO PATHS ETC FIXX!!!!!!!!!!!!!!
     tstr_type=strmid(CFCfile,40,5)
     tstr_date=strmid(CFCfile,45,6)
     tstr=strcompress(tstr_date+', land, Model='+string(modeltype))
     tstr2=strcompress('Land, Model='+string(modeltype))
     imo_str=strmid(yyyymm_str,4,2)
     ;--------
     ; get the factorgrid which performs the land-surface type and
     ; solar zenith angle correction.
     ; Since SAL is normalized to SZA=60 degrees (read the ATBD) we need to use a formula
     ; to convert to other SZAs. This means getting the Briegleb or Dickinson 'd' factor
     ; which depends on the surface type, given by the IGBP data
     ifwantSZAconversion=1
     iyear=2007	; can remain fixed, for now
     monarr=['01','02','03','04','05','06','07','08','09','10','11','12']
     ipoint=where(monarr eq imo_str)
     im=monarr(ipoint)
     get_factorgrid,factorgrid,iyear,im
     cleanSALgridded=SALgridded	; set aside for later plotting
     ;--------
     if (ifwantSZAconversion eq 1) then begin
     SALgridded=SALgridded*factorgrid
     endif
     ; start the regression
     if (COTexist*SALexist*TRSexist*TISexist*CFCexist eq 1) then begin
         ; get the land points
         ; >>>>>>>>>>>>>>>>>>>>>>
         ; >>>>>>>>>>>>>>>>>>>>>>
         ; >>> NOTICE: we are selecting for land points only
         ; >>>>>>>>>>>>>>>>>>>>>>
         ; >>>>>>>>>>>>>>>>>>>>>>
         idx=where(lsmask eq 1 and (longrid ge lonmin and longrid lt lonmax) and (latgrid ge latmin and latgrid lt latmax))
         lonuse=longrid(idx)
         latuse=latgrid(idx)
         ; build regression model
         ; Model 1
         if (modeltype eq 1 ) then begin
             yy=albedo(idx)
             xx=transpose([[SALgridded(idx)],[CFCgridded(idx)],[COTgridded(idx)]])
             gosaveitall,yy,xx,lonuse,latuse,'modeltype1_CMSAF_'+string(ifile)+'.txt'
             endif
         ; Model 2
         if (modeltype eq 2 ) then begin
             yy=albedo(idx)
             xx=transpose([[SALgridded(idx)*(1.0-CFCgridded(idx))],[CFCgridded(idx)],[COTgridded(idx)]])
             endif
         ; Model 3
         if (modeltype eq 3 ) then begin
             yy=albedo(idx)
             xx=transpose([[CFCgridded(idx)],[SALgridded(idx)*(1.0-CFCgridded(idx))]])
             endif
         ; Model 4
         if (modeltype eq 4 ) then begin
             yy=albedo(idx)
             xx=transpose([[CFCgridded(idx)*(1.0-exp(-COTgridded(idx)))],[SALgridded(idx)*(1.0-CFCgridded(idx))]])
             endif
         ; perform regression
         res=REGRESS(xx,yy,/double,sigma=sigs,yfit=yhat,const=const)
         for ijy=0,n_elements(yy)-1,1 do begin
		printf,67,format='(a4,1x,a2,1x,10(f12.6,1x))',strmid(yyyymm_str,0,4),strmid(yyyymm_str,4,2),xx(ijy),xx(*,ijy)
	 endfor
         print,'const=',const
         for k=0,n_elements(res)-1,1 do begin
             print,res(k),' +/- ',sigs(k), '   Z= ',res(k)/sigs(k)
             endfor
         ; calculate the residuals
         residuals=yy-yhat	; observation MINUS model
         sum_residuals=sum_residuals+residuals
         sum_rel_residuals=sum_rel_residuals+residuals/yy
         printf,uw,imo_str,correlate(yy,yhat)^2
         ; calculate the albedo error in percent for each month - units: pct error per pixel
         RMSE=100.*sqrt(total((residuals/yy)^2,/double))/n_elements(idx)
         ; plot the model against the regressand, overplot a diagonal
         loadct,0
         !P.MULTI=[0,3,2]
         ; plot SAL against albedo
         scatter_col,cleanSALgridded(idx),albedo(idx),minx=0,miny=0,maxx=1.0,maxy=1.0,binx=0.02,biny=0.02,$
         color_bar=color_bar,ytitle='TRS/TIS',xtitle='SAL_60',/isotropic,n_lev=4,title=strcompress(tstr_date)
         ; plot Model against albedo
         scatter_col,SALgridded(idx),albedo(idx),minx=0.,miny=0.,maxx=1.0,maxy=1.0,binx=0.02,biny=0.02,$
         color_bar=color_bar,ytitle='TRS/TIS',xtitle='SAL',/isotropic,n_lev=4,$
         title=strcompress(tstr_date)
         oplot,[0,1],[0,1]
         ; plot the fitted model against albedo
         scatter_col,yhat,albedo(idx),minx=0.,miny=0.,maxx=1.0,maxy=1.0,binx=0.02,biny=0.02,$
         color_bar=color_bar,ytitle='TRS/TIS',xtitle='Albedo model',$
         title=strcompress(tstr2),/isotropic,n_lev=4
         oplot,[0,1],[0,1]
         oplot,[0,0.8],[0.2,1.0],linestyle=1	; plot the line defining bad pixels
         ; make a map of residuals
         loadct,13
         !P.MULTI=[1,1,2]
         map_set,/advance,/isotropic,/satellite,sat_p=[8,0,0],title='Residuals, contours step .05'
         datuse=residuals
         go_interpolate,datuse,lonuse,latuse,residuals_gridded,longrid,latgrid
         ; set ocean pixels and areas aoutside the regression grid to NaN - for plotting reasons only
         ipoint=where(lsmask eq 0 or (longrid le lonmin or longrid gt lonmax) or (latgrid le latmin or latgrid gt latmax))
         ;
         residuals_gridded(ipoint)=!VALUES.F_NAN
         nlevels=31
         levels=findgen(nlevels)/float(nlevels-1)-0.5
         levels=levels/3.
         contour,residuals_gridded,longrid,latgrid,/overplot,/cell_fill,levels=levels
         levels=[-0.3,-0.2,-0.15,-0.1,-0.05,0.0,0.05,0.1,0.15,0.2,0.3]
         nlevels=8
         ; nlevels=11
         cthick=indgen(nlevels)*0+1
         cstyle=indgen(nlevels)*0
         cthick(where(levels eq 0))=2
         cstyle(where(levels lt 0))=3
         contour,residuals_gridded,longrid,latgrid,/overplot,$
         levels=levels,c_thick=cthick,c_linestyle=cstyle,c_colors=indgen(nlevels)*0+255
         make_stack_residuals,residuals_gridded,longrid,latgrid,icount
         map_continents,/overplot
         map_grid,/overplot
         ; print out the regression results on screen 
         ; and in a file for later plotting with "plot_regression_results.pro"
         print,"regression coefficients"
         print,const
         printf,w,const,0.0
         for k=0,n_elements(res)-1,1 do begin
             print,res(k),' +/- ',sigs(k), '   Z= ',res(k)/sigs(k)
             printf,w,res(k),sigs(k)
             endfor
         printf,w,RMSE,911
         endif
     icount=icount+1
     endfor
 print,'----------------------------------------------------------------------'
 close,1
 close,2
 close,3
 close,4
 close,5
 close,w
 free_lun,w
 free_lun,uw
 ; store the average TIS,TRS,CFC and SAL
 write_netcdf,longrid,latgrid,sum_TRSgridded/float(nmonths),strcompress(exp_str+'mean_TRS.nc',/remove_all),'Mean_TRS'
 write_netcdf,longrid,latgrid,sum_TISgridded/float(nmonths),strcompress(exp_str+'mean_TIS.nc',/remove_all),'Mean_TIS'
 write_netcdf,longrid,latgrid,sum_CFCgridded/float(nmonths),strcompress(exp_str+'mean_CFC.nc',/remove_all),'Mean_CFC'
 write_netcdf,longrid,latgrid,sum_SALgridded/float(nmonths),strcompress(exp_str+'mean_SAL.nc',/remove_all),'Mean_SAL'
 write_netcdf,longrid,latgrid,sum_COTgridded/float(nmonths),strcompress(exp_str+'mean_COT.nc',/remove_all),'Mean_COT'
 ;..............................................
 ; get the CERES albedo - if the netcdf file exists read it, otherwise produce it...
 if (file_test('CERES_regridded.nc')) then begin
     print,'File exists'
     get_CERES_albedo_nc,cereslon,cereslat,CERES_gridded,'CERES_regridded.nc'
     endif else begin
     get_CERES_albedo,'CERES/CERES_SurfaceAlbedo.nc',ceresalbedo,cereslon,cereslat
     ceresalbedo=rebin(ceresalbedo,360,180)
     cereslon=rebin(cereslon,360,180)
     cereslat=rebin(cereslat,360,180)
     l=size(ceresalbedo,/dimensions)
     go_interpolate,ceresalbedo,cereslon,cereslat,CERES_gridded,longrid,latgrid
     l=size(CERES_gridded,/dimensions)
     openw,78,'CERESalbedoGridded.dat'
     for k=0,l(0)-1,1 do begin
         for kk=0,l(1)-1,1 do begin
             printf,78,longrid(k,kk),latgrid(k,kk),CERES_gridded(k,kk)/100.0
             endfor
         endfor
     close,78
     print,'The CERES gridded grid is now in a file ...'
     write_netcdf,longrid,latgrid,CERES_gridded/100.,strcompress('CERES_regridded.nc',/remove_all),'CERES_albedo'
     endelse
 ;..............................................
 ; write out the residuals as a table suitable for mapping. Write the mean over time in each grid point
 openw,77,strcompress(exp_str+'_mean_residuals.dat',/remove_all)
 for k=0,n_elements(idx)-1,1 do begin
     printf,77,longrid(idx(k)),latgrid(idx(k)),sum_residuals(k)/float(nmonths),sum_rel_residuals(k)/float(nmonths)
     endfor
 close,77
 ; also write out the IGBP types
 openw,78,strcompress(exp_str+'_IGBPgrid.dat',/remove_all)
 lll=size(IGBP,/dimensions)
 nIGBPlon=lll(0)
 nIGBPlat=lll(1)
 for k=0,nIGBPlon-1,1 do begin
     for kk=0,nIGBPlat-1,1 do begin
         printf,78,lonIGBP(k),latIGBP(kk),IGBP(k,kk)
         endfor
     endfor
 close,78
 ;..............................................
 ; make the map of annual cycle in SAL
 get_map_of_annual_cycle,SALstack,longrid,latgrid,map_of_cycle
 go_save_stack,exp_str,'SAL',SALstack,longrid,latgrid,yyyymm_arr
 go_save_stack,exp_str,'CFC',CFCstack,longrid,latgrid,yyyymm_arr
 ; go and get the Land-Sea mask
 file=path+'/cmsaf/cmsaf-cld3/pthejll/CMSAFDATA/AUXILLIARY/lsmask.nc'
 get_lsmask_gridded,file,lsmask,lsmasklon_DONOTUSE,lsmasklat_DONOTUSE
 map_of_cycle(where(lsmask eq 0))=!Values.F_NAN
 device,/close
 ;
 set_plot,'ps'
 device,/color,filename=strcompress(exp_str+'map_of_annual_SAL_cycle.ps',/remove_all)
 decomposed=0
 loadct,13
 levels=findgen(11)/10.-0.5
 levels=levels*.5
 cthick=findgen(11)*0+1
 cthick(where(levels eq 0)) = 3
 map_set,/satellite,/isotropic,sat_p=[8,0,0]
 contour,map_of_cycle,longrid,latgrid,nlevels=101,/cell_fill,/overplot
 contour,map_of_cycle,longrid,latgrid,levels=levels,/downhill,/overplot
 map_continents,/overplot
 ;..............................................
 help,residuals_gridded_stack,longrid,latgrid,yyyymm_arr
 make_zonal_mean_residual,residuals_gridded_stack,longrid,latgrid,yyyymm_arr
 close,67
 end
